/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.89 Revision 1.133
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.89 2011/03/03 21:39:29 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.133 2012/06/18 21:33:50 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
44 ;;
45esac
46
47IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
21 [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] && 49if version_is_at_least 4.8; then
22 IUSE="+exceptions" 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
23else 51 version_is_at_least 4.8.3 || IUSE+=" qpa"
24 MY_P=qt-x11-opensource-src-${MY_PV}
25fi 52fi
26 53
27HOMEPAGE="http://qt.nokia.com/" 54DEPEND="virtual/pkgconfig"
28SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 55if [[ ${QT4_BUILD_TYPE} == live ]]; then
29 56 DEPEND+=" dev-lang/perl"
30LICENSE="|| ( LGPL-2.1 GPL-3 )" 57fi
31IUSE+=" debug pch aqua"
32 58
33RDEPEND=" 59RDEPEND="
34 !<x11-libs/qt-assistant-${PV} 60 !<x11-libs/qt-assistant-${PV}:4
35 !>x11-libs/qt-assistant-${PV}-r9999 61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
36 !<x11-libs/qt-core-${PV} 64 !<x11-libs/qt-core-${PV}:4
37 !>x11-libs/qt-core-${PV}-r9999 65 !>x11-libs/qt-core-${PV}-r9999:4
38 !<x11-libs/qt-dbus-${PV} 66 !<x11-libs/qt-dbus-${PV}:4
39 !>x11-libs/qt-dbus-${PV}-r9999 67 !>x11-libs/qt-dbus-${PV}-r9999:4
68 !<x11-libs/qt-declarative-${PV}:4
69 !>x11-libs/qt-declarative-${PV}-r9999:4
40 !<x11-libs/qt-demo-${PV} 70 !<x11-libs/qt-demo-${PV}:4
41 !>x11-libs/qt-demo-${PV}-r9999 71 !>x11-libs/qt-demo-${PV}-r9999:4
42 !<x11-libs/qt-gui-${PV} 72 !<x11-libs/qt-gui-${PV}:4
43 !>x11-libs/qt-gui-${PV}-r9999 73 !>x11-libs/qt-gui-${PV}-r9999:4
44 !<x11-libs/qt-multimedia-${PV} 74 !<x11-libs/qt-multimedia-${PV}:4
45 !>x11-libs/qt-multimedia-${PV}-r9999 75 !>x11-libs/qt-multimedia-${PV}-r9999:4
46 !<x11-libs/qt-opengl-${PV} 76 !<x11-libs/qt-opengl-${PV}:4
47 !>x11-libs/qt-opengl-${PV}-r9999 77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
48 !<x11-libs/qt-phonon-${PV} 80 !<x11-libs/qt-phonon-${PV}:4
49 !>x11-libs/qt-phonon-${PV}-r9999 81 !>x11-libs/qt-phonon-${PV}-r9999:4
50 !<x11-libs/qt-qt3support-${PV} 82 !<x11-libs/qt-qt3support-${PV}:4
51 !>x11-libs/qt-qt3support-${PV}-r9999 83 !>x11-libs/qt-qt3support-${PV}-r9999:4
52 !<x11-libs/qt-script-${PV} 84 !<x11-libs/qt-script-${PV}:4
53 !>x11-libs/qt-script-${PV}-r9999 85 !>x11-libs/qt-script-${PV}-r9999:4
54 !<x11-libs/qt-sql-${PV} 86 !<x11-libs/qt-sql-${PV}:4
55 !>x11-libs/qt-sql-${PV}-r9999 87 !>x11-libs/qt-sql-${PV}-r9999:4
56 !<x11-libs/qt-svg-${PV} 88 !<x11-libs/qt-svg-${PV}:4
57 !>x11-libs/qt-svg-${PV}-r9999 89 !>x11-libs/qt-svg-${PV}-r9999:4
58 !<x11-libs/qt-test-${PV} 90 !<x11-libs/qt-test-${PV}:4
59 !>x11-libs/qt-test-${PV}-r9999 91 !>x11-libs/qt-test-${PV}-r9999:4
60 !<x11-libs/qt-webkit-${PV} 92 !<x11-libs/qt-webkit-${PV}:4
61 !>x11-libs/qt-webkit-${PV}-r9999 93 !>x11-libs/qt-webkit-${PV}-r9999:4
62 !<x11-libs/qt-xmlpatterns-${PV} 94 !<x11-libs/qt-xmlpatterns-${PV}:4
63 !>x11-libs/qt-xmlpatterns-${PV}-r9999 95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
64" 96"
65 97
66S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
67 99
68# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
69# @DESCRIPTION: 101# @DESCRIPTION:
70# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
71qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
72 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 104 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
73 105
74 # Protect users by not allowing downgrades between releases 106 # Protect users by not allowing downgrades between releases.
75 # Downgrading revisions within the same release should be allowed 107 # Downgrading revisions within the same release should be allowed.
76 if has_version '>'${CATEGORY}/${P}-r9999 ; then 108 if has_version ">${CATEGORY}/${P}-r9999:4"; then
77 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 109 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
78 eerror "Sanity check to keep you from breaking your system:" 110 eerror " *** Sanity check to keep you from breaking your system ***"
79 eerror " Downgrading Qt is completely unsupported and will break your system!" 111 eerror "Downgrading Qt is completely unsupported and will break your system!"
80 die "aborting to save your system" 112 die "aborting to save your system"
81 else 113 else
82 ewarn "Downgrading Qt is completely unsupported and will break your system!" 114 ewarn "Downgrading Qt is completely unsupported and will break your system!"
83 fi 115 fi
84 fi
85
86 if [[ "${PN}" == "qt-webkit" ]]; then
87 eshopts_push -s extglob
88 if is-flagq '-g?(gdb)?([1-9])'; then
89 echo
90 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
91 ewarn "You may experience really long compilation times and/or increased memory usage."
92 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
93 ewarn "For more info check out bug #307861"
94 echo
95 fi
96 eshopts_pop
97 fi 116 fi
98 117
99 PATH="${S}/bin${PATH:+:}${PATH}" 118 PATH="${S}/bin${PATH:+:}${PATH}"
100 if [[ ${CHOST} != *-darwin* ]]; then 119 if [[ ${CHOST} != *-darwin* ]]; then
101 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 120 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
106 # avoid extract failure. 125 # avoid extract failure.
107 [[ ${CHOST} == *-apple-darwin* ]] && \ 126 [[ ${CHOST} == *-apple-darwin* ]] && \
108 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 127 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
109 ${QT4_EXTRACT_DIRECTORIES}" 128 ${QT4_EXTRACT_DIRECTORIES}"
110 fi 129 fi
111
112 # Make sure ebuilds use the required EAPI
113 if [[ ${EAPI} != [23] ]]; then
114 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
115 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
116 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
117 die "qt4-build eclass requires EAPI=2 or EAPI=3"
118 fi
119
120 if ! version_is_at_least 4.1 $(gcc-version); then
121 ewarn "Using a GCC version lower than 4.1 is not supported!"
122 fi
123} 130}
131
132# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
133# @DEFAULT_UNSET
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
124 137
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 138# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
139# @DEFAULT_UNSET
126# @DESCRIPTION: 140# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 141# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 142# code should be compiled. This is a space-separated list.
129
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt
133# tarball
134 143
135# @FUNCTION: qt4-build_src_unpack 144# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 145# @DESCRIPTION:
137# Unpacks the sources 146# Unpacks the sources.
138qt4-build_src_unpack() { 147qt4-build_src_unpack() {
139 setqtenv 148 setqtenv
140 local target targets= 149
150 if ! version_is_at_least 4.1 $(gcc-version); then
151 ewarn "Using a GCC version lower than 4.1 is not supported."
152 fi
153
154 if [[ ${PN} == qt-webkit ]]; then
155 eshopts_push -s extglob
156 if is-flagq '-g?(gdb)?([1-9])'; then
157 echo
158 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
159 ewarn "You may experience really long compilation times and/or increased memory usage."
160 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
161 ewarn "For more info check out https://bugs.gentoo.org/307861"
162 echo
163 fi
164 eshopts_pop
165 fi
166
167 case ${QT4_BUILD_TYPE} in
168 live)
169 git-2_src_unpack
170 ;;
171 release)
172 local tarball="${MY_P}.tar.gz" target= targets=
141 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 173 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
142 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 174 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
143 ${QT4_EXTRACT_DIRECTORIES}; do 175 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
176 do
144 targets+=" ${MY_P}/${target}" 177 targets+="${MY_P}/${target} "
145 done 178 done
146 179
180 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
147 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 181 tar -xzf "${DISTDIR}/${tarball}" ${targets}
148 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 182 eend $? || die "failed to unpack"
183 ;;
184 esac
149} 185}
150 186
151# @ECLASS-VARIABLE: PATCHES 187# @ECLASS-VARIABLE: PATCHES
188# @DEFAULT_UNSET
152# @DESCRIPTION: 189# @DESCRIPTION:
153# In case you have patches to apply, specify them in PATCHES variable. Make sure 190# PATCHES array variable containing all various patches to be applied.
154# to specify the full path. This variable is necessary for src_prepare phase. 191# This variable is expected to be defined in global scope of ebuild.
155# example: 192# Make sure to specify the full path. This variable is utilised in
156# PATCHES="${FILESDIR}"/mypatch.patch 193# src_unpack/src_prepare phase, based on EAPI.
157# ${FILESDIR}"/mypatch2.patch"
158# 194#
195# @CODE
196# PATCHES=( "${FILESDIR}/mypatch.patch"
197# "${FILESDIR}/patches_folder/" )
198# @CODE
159 199
160# @FUNCTION: qt4-build_src_prepare 200# @FUNCTION: qt4-build_src_prepare
161# @DESCRIPTION: 201# @DESCRIPTION:
162# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 202# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
163# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 203# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
164qt4-build_src_prepare() { 204qt4-build_src_prepare() {
165 setqtenv 205 setqtenv
166 cd "${S}" 206
167 207 if [[ ${QT4_BUILD_TYPE} == live ]]; then
168 # fix qt 4.7 regression that skips -fvisibility=hidden 208 QTDIR="." ./bin/syncqt || die "syncqt failed"
209 fi
210
169 if version_is_at_least "4.7.0_beta1"; then 211 if version_is_at_least 4.7; then
170 sed -e "s/^gcc|g++)/*gcc|*g++)/" \ 212 # avoid X11 dependency in non-gui packages
171 -i config.tests/unix/fvisibility.test ||
172 die "visibility fixing sed failed"
173 fi
174 # fix libx11 dependency on non X packages
175 if version_is_at_least "4.7.0_beta2"; then
176 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 213 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
177 hasq ${PN} ${NOLIBX11PKG} && qt_nolibx11 214 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
178 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup
179 fi 215 fi
180 216
181 if use aqua; then 217 if use aqua; then
182 # provide a proper macx-g++-64 218 # provide a proper macx-g++-64
183 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 219 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
184 220
185 sed -e '/^CONFIG/s:app_bundle::' \ 221 sed -e '/^CONFIG/s:app_bundle::' \
186 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 222 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
187 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 223 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
188 fi 224 fi
189 225
190 if [[ ${PN} != qt-core ]]; then 226 if [[ ${PN} != qt-core ]]; then
191 skip_qmake_build_patch 227 skip_qmake_build
192 skip_project_generation_patch 228 skip_project_generation
193 symlink_binaries_to_buildtree 229 symlink_binaries_to_buildtree
194 fi 230 fi
195 231
196 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 232 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
197 # qmake bus errors with -O2 but -O3 works 233 # qmake bus errors with -O2 or -O3 but -O1 works
234 # Bug 373061
198 replace-flags -O2 -O3 235 replace-flags -O[23] -O1
199 fi 236 fi
200 237
201 # Bug 178652 238 # Bug 178652
202 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 239 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
203 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 240 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
204 append-flags -fno-gcse 241 append-flags -fno-gcse
205 fi 242 fi
206 243
244 if use_if_iuse c++0x; then
245 append-cxxflags -std=c++0x
246 fi
247
207 # Unsupported old gcc versions - hardened needs this :( 248 # Unsupported old gcc versions - hardened needs this :(
208 if [[ $(gcc-major-version) -lt 4 ]] ; then 249 if [[ $(gcc-major-version) -lt 4 ]]; then
209 ewarn "Appending -fno-stack-protector to CXXFLAGS" 250 ewarn "Appending -fno-stack-protector to CXXFLAGS"
210 append-cxxflags -fno-stack-protector 251 append-cxxflags -fno-stack-protector
211 # Bug 253127 252 # Bug 253127
212 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 253 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
213 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 254 -i mkspecs/common/g++.conf || die
214 fi 255 fi
215 256
216 # Bug 261632 257 # Bug 261632
217 if use ppc64; then 258 if use ppc64; then
218 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 259 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
219 append-flags -mminimal-toc 260 append-flags -mminimal-toc
220 fi 261 fi
221 262
222 # Bug 282984 && Bug 295530 263 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
223 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 264 sed -e "/^SYSTEM_VARIABLES=/i \
224 -i configure || die "sed qmake compilers failed" 265 CC='$(tc-getCC)'\n\
225 # bug 321335 266 CXX='$(tc-getCXX)'\n\
267 CFLAGS='${CFLAGS}'\n\
268 CXXFLAGS='${CXXFLAGS}'\n\
269 LDFLAGS='${LDFLAGS}'\n" \
270 -i configure \
271 || die "sed SYSTEM_VARIABLES failed"
272
273 # Respect CC, CXX, LINK and *FLAGS in config.tests
274 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
275 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
276 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
277 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
278 || die "sed config.tests failed"
279
226 if version_is_at_least 4.6; then 280 if ! version_is_at_least 4.8; then
227 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 281 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
228 xargs -0 \ 282 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
229 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \
230 -i || die "sed test compilers failed"
231 fi 283 fi
232 284
233 # Bug 172219 285 # Bug 172219
234 sed -e "s:X11R6/::" \ 286 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
235 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
236 287
237 if [[ ${CHOST} == *-darwin* ]]; then 288 if [[ ${CHOST} == *-darwin* ]]; then
238 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 289 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
239 # crippled (by design) :/ 290 # crippled (by design) :/
291 local mac_gpp_conf=
292 if [[ -f mkspecs/common/mac-g++.conf ]]; then
293 # qt < 4.8 has mac-g++.conf
294 mac_gpp_conf="mkspecs/common/mac-g++.conf"
295 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
296 # qt >= 4.8 has g++-macx.conf
297 mac_gpp_conf="mkspecs/common/g++-macx.conf"
298 else
299 die "no known conf file for mac found"
300 fi
301 sed \
240 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 302 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
241 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 303 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
242 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 304 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
243 -e "s:-arch\s\w*::g" \ 305 -e "s:-arch\s\w*::g" \
244 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 306 -i ${mac_gpp_conf} \
307 || die "sed ${mac_gpp_conf} failed"
245 308
246 # Fix configure's -arch settings that appear in qmake/Makefile and also 309 # Fix configure's -arch settings that appear in qmake/Makefile and also
247 # fix arch handling (automagically duplicates our -arch arg and breaks 310 # fix arch handling (automagically duplicates our -arch arg and breaks
248 # pch). Additionally disable Xarch support. 311 # pch). Additionally disable Xarch support.
312 local mac_gcc_confs="${mac_gpp_conf}"
313 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
314 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
315 fi
249 sed \ 316 sed \
250 -e "s:-arch i386::" \ 317 -e "s:-arch i386::" \
251 -e "s:-arch ppc::" \ 318 -e "s:-arch ppc::" \
252 -e "s:-arch x86_64::" \ 319 -e "s:-arch x86_64::" \
253 -e "s:-arch ppc64::" \ 320 -e "s:-arch ppc64::" \
254 -e "s:-arch \$i::" \ 321 -e "s:-arch \$i::" \
255 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 322 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
256 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 323 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
257 -e "s:-Xarch_x86_64::g" \ 324 -e "s:-Xarch_x86_64::g" \
258 -e "s:-Xarch_ppc64::g" \ 325 -e "s:-Xarch_ppc64::g" \
259 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 326 -i configure ${mac_gcc_confs} \
327 || die "sed -arch/-Xarch failed"
260 328
261 # On Snow Leopard don't fall back to 10.5 deployment target. 329 # On Snow Leopard don't fall back to 10.5 deployment target.
262 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 330 if [[ ${CHOST} == *-apple-darwin10 ]]; then
263 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 331 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
264 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 332 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
265 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 333 -i configure ${mac_gpp_conf} \
334 || die "sed deployment target failed"
266 fi 335 fi
267 fi 336 fi
268 337
269 # this one is needed for all systems with a separate -liconv, apart from 338 # this one is needed for all systems with a separate -liconv, apart from
270 # Darwin, for which the sources already cater for -liconv 339 # Darwin, for which the sources already cater for -liconv
271 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 340 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
272 sed \ 341 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
273 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
274 -i config.tests/unix/iconv/iconv.pro \ 342 -i config.tests/unix/iconv/iconv.pro \
275 || die "sed on iconv.pro failed" 343 || die "sed iconv.pro failed"
276 fi 344 fi
277 345
278 # we need some patches for Solaris 346 # we need some patches for Solaris
279 sed -i \
280 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 347 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
281 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 348 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
282 # use GCC over SunStudio 349 # use GCC over SunStudio
283 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 350 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
284 # don't flirt with non-Prefix stuff, we're quite possessive 351 # do not flirt with non-Prefix stuff, we're quite possessive
285 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 352 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
286 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 353 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
287 # strip predefined CFLAGS from qmake ( bug #312689 )
288 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
289 354
290 base_src_prepare 355 base_src_prepare
291} 356}
292 357
293# @FUNCTION: qt4-build_src_configure 358# @FUNCTION: qt4-build_src_configure
294# @DESCRIPTION: 359# @DESCRIPTION:
295# Default configure phase 360# Default configure phase
296qt4-build_src_configure() { 361qt4-build_src_configure() {
297 setqtenv 362 setqtenv
298 myconf="$(standard_configure_options) ${myconf}" 363
364 local conf="
365 -prefix ${QTPREFIXDIR}
366 -bindir ${QTBINDIR}
367 -libdir ${QTLIBDIR}
368 -docdir ${QTDOCDIR}
369 -headerdir ${QTHEADERDIR}
370 -plugindir ${QTPLUGINDIR}
371 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
372 -datadir ${QTDATADIR}
373 -translationdir ${QTTRANSDIR}
374 -sysconfdir ${QTSYSCONFDIR}
375 -examplesdir ${QTEXAMPLESDIR}
376 -demosdir ${QTDEMOSDIR}
377 -opensource -confirm-license
378 -shared -fast -largefile -stl -verbose
379 -nomake examples -nomake demos"
380
381 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
382 # $(tc-arch). Therefore we convert it to supported values.
383 case "$(tc-arch)" in
384 amd64|x64-*) conf+=" -arch x86_64" ;;
385 ppc-macos) conf+=" -arch ppc" ;;
386 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
387 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
388 x86-macos) conf+=" -arch x86" ;;
389 x86|x86-*) conf+=" -arch i386" ;;
390 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
391 hppa|sh) conf+=" -arch generic" ;;
392 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
393 esac
394
395 conf+=" -platform $(qt_mkspecs_dir)"
396
397 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
398
399 # debug/release
400 if use debug; then
401 conf+=" -debug"
402 else
403 conf+=" -release"
404 fi
405 conf+=" -no-separate-debug-info"
406
407 # exceptions USE flag
408 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
409
410 # disable rpath on Qt >= 4.8 (bug 380415)
411 # but leave it enabled on prefix (bug 417169)
412 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
413
414 # precompiled headers don't work on hardened, where the flag is masked
415 conf+=" $(qt_use pch)"
416
417 # -reduce-relocations
418 # This flag seems to introduce major breakage to applications,
419 # mostly to be seen as a core dump with the message "QPixmap: Must
420 # construct a QApplication before a QPaintDevice" on Solaris.
421 # -- Daniel Vergien
422 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
299 423
300 # this one is needed for all systems with a separate -liconv, apart from 424 # this one is needed for all systems with a separate -liconv, apart from
301 # Darwin, for which the sources already cater for -liconv 425 # Darwin, for which the sources already cater for -liconv
302 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 426 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
303 myconf+=" -liconv" 427 conf+=" -liconv"
428 fi
304 429
305 if has glib ${IUSE//+} && use glib; then 430 if use_if_iuse glib; then
306 # use -I, -L and -l from configure
307 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 431 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
308 # avoid the -pthread argument 432 # avoid the -pthread argument
309 myconf+=" ${glibflags//-pthread}" 433 conf+=" ${glibflags//-pthread}"
310 unset glibflags 434 unset glibflags
311 fi 435 fi
312 436
437 if use_if_iuse qpa; then
438 echo
439 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
440 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
441 ewarn "disable it before reporting any bugs related to this useflag."
442 echo
443 conf+=" -qpa"
444 fi
445
313 if use aqua ; then 446 if use aqua; then
314 # On (snow) leopard use the new (frameworked) cocoa code. 447 # On (snow) leopard use the new (frameworked) cocoa code.
315 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 448 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
316 myconf+=" -cocoa -framework" 449 conf+=" -cocoa -framework"
450 # We need the source's headers, not the installed ones.
451 conf+=" -I${S}/include"
452 # Add hint for the framework location.
453 conf+=" -F${QTLIBDIR}"
317 454
318 # We are crazy and build cocoa + qt3support :-) 455 # We are crazy and build cocoa + qt3support :-)
319 if use qt3support; then 456 if use qt3support; then
320 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 457 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
321 -i configure 458 -i configure || die
322 fi 459 fi
323 460 else
324 # We need the source's headers, not the installed ones. 461 conf+=" -no-framework"
325 myconf+=" -I${S}/include"
326
327 # Add hint for the framework location.
328 myconf+=" -F${QTLIBDIR}"
329 fi 462 fi
330 else 463 else
331 # freetype2 include dir is non-standard, thus include it on configure 464 # freetype2 include dir is non-standard, thus pass it to configure
332 # use -I from configure
333 myconf+=" $(pkg-config --cflags freetype2)" 465 conf+=" $(pkg-config --cflags-only-I freetype2)"
334 fi 466 fi
335 467
336 # Disable SSE4.x, since auto-detection is currently broken 468 conf+=" ${myconf}"
337 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 469 myconf=
338 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
339 470
340 echo ./configure ${myconf} 471 echo ./configure ${conf}
341 ./configure ${myconf} || die "./configure failed" 472 ./configure ${conf} || die "./configure failed"
342 myconf="" 473
474 prepare_directories ${QT4_TARGET_DIRECTORIES}
343} 475}
344 476
345# @FUNCTION: qt4-build_src_compile 477# @FUNCTION: qt4-build_src_compile
478# @DESCRIPTION:
346# @DESCRIPTION: Actual compile phase 479# Actual compile phase
347qt4-build_src_compile() { 480qt4-build_src_compile() {
348 setqtenv 481 setqtenv
349 482
350 build_directories ${QT4_TARGET_DIRECTORIES} 483 build_directories ${QT4_TARGET_DIRECTORIES}
351} 484}
352 485
353# @FUNCTION: qt4-build_src_test 486# @FUNCTION: qt4-build_src_test
354# @DESCRIPTION: 487# @DESCRIPTION:
355# Runs tests only in target directories. 488# Runs tests only in target directories.
356qt4-build_src_test() { 489qt4-build_src_test() {
490 # QtMultimedia does not have any test suite (bug #332299)
491 [[ ${PN} == qt-multimedia ]] && return
492
357 for dir in ${QT4_TARGET_DIRECTORIES}; do 493 for dir in ${QT4_TARGET_DIRECTORIES}; do
358 emake -j1 check -C ${dir} 494 emake -j1 check -C ${dir}
359 done 495 done
360} 496}
361 497
362# @FUNCTION: fix_includes 498# @FUNCTION: fix_includes
363# @DESCRIPTION: 499# @DESCRIPTION:
364# For MacOSX we need to add some symlinks when frameworks are 500# For MacOS X we need to add some symlinks when frameworks are
365# being used, to avoid complications with some more or less stupid packages. 501# being used, to avoid complications with some more or less stupid packages.
366fix_includes() { 502fix_includes() {
367 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 503 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
504 local frw dest f h rdir
368 # Some packages tend to include <Qt/...> 505 # Some packages tend to include <Qt/...>
369 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 506 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
370 507
371 # Fake normal headers when frameworks are installed... eases life later on 508 # Fake normal headers when frameworks are installed... eases life later
372 local dest f 509 # on, make sure we use relative links though, as some ebuilds assume
510 # these dirs exist in src_install to add additional files
511 f=${QTHEADERDIR}
512 h=${QTLIBDIR}
513 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
514 f=${f#*/}
515 h=${h#*/}
516 done
517 rdir=${h}
518 f="../"
519 while [[ ${h} == */* ]] ; do
520 f="${f}../"
521 h=${h#*/}
522 done
523 rdir="${f}${rdir}"
524
373 for frw in "${D}${QTLIBDIR}"/*.framework; do 525 for frw in "${D}${QTLIBDIR}"/*.framework; do
374 [[ -e "${frw}"/Headers ]] || continue 526 [[ -e "${frw}"/Headers ]] || continue
375 f=$(basename ${frw}) 527 f=$(basename ${frw})
376 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 528 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
377 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 529 dosym "${rdir}"/${f}/Headers "${dest}"
378 530
379 # Link normal headers as well. 531 # Link normal headers as well.
380 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 532 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
381 h=$(basename ${hdr}) 533 h=$(basename ${hdr})
382 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 534 dosym "../${rdir}"/${f}/Headers/${h} \
535 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
383 done 536 done
384 done 537 done
385 fi 538 fi
386} 539}
387 540
389# @DESCRIPTION: 542# @DESCRIPTION:
390# Perform the actual installation including some library fixes. 543# Perform the actual installation including some library fixes.
391qt4-build_src_install() { 544qt4-build_src_install() {
392 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 545 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
393 setqtenv 546 setqtenv
547
394 install_directories ${QT4_TARGET_DIRECTORIES} 548 install_directories ${QT4_TARGET_DIRECTORIES}
395 install_qconfigs 549 install_qconfigs
396 fix_library_files 550 fix_library_files
397 fix_includes 551 fix_includes
552
398 # remove .la files since we are building only shared Qt libraries 553 # remove .la files since we are building only shared Qt libraries
399 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 554 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
400} 555}
401 556
402# @FUNCTION: setqtenv 557# @FUNCTION: setqtenv
558# @INTERNAL
403setqtenv() { 559setqtenv() {
404 # Set up installation directories 560 # Set up installation directories
405 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
406 QTPREFIXDIR=${EPREFIX}/usr 561 QTPREFIXDIR=${EPREFIX}/usr
407 QTBINDIR=${EPREFIX}/usr/bin 562 QTBINDIR=${EPREFIX}/usr/bin
408 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 563 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
409 QMAKE_LIBDIR_QT=${QTLIBDIR}
410 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 564 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
411 QTDATADIR=${EPREFIX}/usr/share/qt4
412 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 565 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
413 QTHEADERDIR=${EPREFIX}/usr/include/qt4 566 QTHEADERDIR=${EPREFIX}/usr/include/qt4
414 QTPLUGINDIR=${QTLIBDIR}/plugins 567 QTPLUGINDIR=${QTLIBDIR}/plugins
568 QTIMPORTDIR=${QTLIBDIR}/imports
569 QTDATADIR=${EPREFIX}/usr/share/qt4
570 QTTRANSDIR=${QTDATADIR}/translations
415 QTSYSCONFDIR=${EPREFIX}/etc/qt4 571 QTSYSCONFDIR=${EPREFIX}/etc/qt4
416 QTTRANSDIR=${QTDATADIR}/translations
417 QTEXAMPLESDIR=${QTDATADIR}/examples 572 QTEXAMPLESDIR=${QTDATADIR}/examples
418 QTDEMOSDIR=${QTDATADIR}/demos 573 QTDEMOSDIR=${QTDATADIR}/demos
574 QMAKE_LIBDIR_QT=${QTLIBDIR}
419 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 575 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
576
420 PLATFORM=$(qt_mkspecs_dir) 577 PLATFORM=$(qt_mkspecs_dir)
421
422 unset QMAKESPEC 578 unset QMAKESPEC
423}
424 579
425# @FUNCTION: standard_configure_options 580 export XDG_CONFIG_HOME="${T}"
426# @DESCRIPTION:
427# Sets up some standard configure options, like libdir (if necessary), whether
428# debug info is wanted or not.
429standard_configure_options() {
430 local myconf=
431
432 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
433
434 # Disable visibility explicitly if gcc version isn't 4
435 if [[ $(gcc-major-version) -lt 4 ]]; then
436 myconf+=" -no-reduce-exports"
437 fi
438
439 # precompiled headers doesn't work on hardened, where the flag is masked.
440 myconf+=" $(qt_use pch)"
441
442 if use debug; then
443 myconf+=" -debug"
444 else
445 myconf+=" -release"
446 fi
447 myconf+=" -no-separate-debug-info"
448
449 use aqua && myconf+=" -no-framework"
450
451 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
452 # $(tc-arch). Therefore we convert it to supported values.
453 case "$(tc-arch)" in
454 amd64|x64-*) myconf+=" -arch x86_64" ;;
455 ppc-macos) myconf+=" -arch ppc" ;;
456 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
457 sparc|sparc-*) myconf+=" -arch sparc" ;;
458 x86-macos) myconf+=" -arch x86" ;;
459 x86|x86-*) myconf+=" -arch i386" ;;
460 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
461 hppa|sh) myconf+=" -arch generic" ;;
462 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
463 esac
464
465 # 4.5: build everything but qt-xmlpatterns w/o exceptions
466 # 4.6: exceptions USE flag
467 local exceptions="-exceptions"
468 case "${PV}" in
469 4.5.*)
470 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
471 ;;
472 *)
473 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
474 ;;
475 esac
476
477 # note about -reduce-relocations:
478 # That flag seems to introduce major breakage to applications,
479 # mostly to be seen as a core dump with the message "QPixmap: Must
480 # construct a QApplication before a QPaintDevice" on Solaris
481 # -- Daniel Vergien
482 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
483
484 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
485 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
486 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
487 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
488 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
489 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
490 ${exceptions}
491 -nomake examples -nomake demos"
492
493 echo "${myconf}"
494} 581}
495 582
496# @FUNCTION: build_directories 583# @FUNCTION: prepare_directories
497# @USAGE: < directories > 584# @USAGE: < directories >
585# @INTERNAL
498# @DESCRIPTION: 586# @DESCRIPTION:
499# Compiles the code in $QT4_TARGET_DIRECTORIES 587# Generates Makefiles for the given list of directories.
500build_directories() { 588prepare_directories() {
501 for x in "$@"; do 589 for x in "$@"; do
502 pushd "${S}"/${x} >/dev/null 590 pushd "${S}"/${x} >/dev/null || die
591 einfo "Running qmake in: ${x}"
503 # avoid running over the maximum argument number, bug #299810 592 # avoid running over the maximum argument number, bug #299810
504 { 593 {
505 echo "${S}"/mkspecs/common/*.conf 594 echo "${S}"/mkspecs/common/*.conf
506 find "${S}" -name '*.pr[io]' 595 find "${S}" -name '*.pr[io]'
507 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 596 } | xargs sed -i \
597 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
598 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
599 || die
508 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 600 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
601 popd >/dev/null || die
602 done
603}
604
605
606# @FUNCTION: build_directories
607# @USAGE: < directories >
608# @INTERNAL
609# @DESCRIPTION:
610# Compiles the code in the given list of directories.
611build_directories() {
612 for x in "$@"; do
613 pushd "${S}"/${x} >/dev/null || die
509 emake CC="$(tc-getCC)" \ 614 emake CC="$(tc-getCC)" \
510 CXX="$(tc-getCXX)" \ 615 CXX="$(tc-getCXX)" \
511 LINK="$(tc-getCXX)" || die "emake failed" 616 LINK="$(tc-getCXX)" || die "emake failed"
512 popd >/dev/null 617 popd >/dev/null || die
513 done 618 done
514} 619}
515 620
516# @FUNCTION: install_directories 621# @FUNCTION: install_directories
517# @USAGE: < directories > 622# @USAGE: < directories >
623# @INTERNAL
518# @DESCRIPTION: 624# @DESCRIPTION:
519# run emake install in the given directories, which are separated by spaces 625# Runs emake install in the given directories, which are separated by spaces.
520install_directories() { 626install_directories() {
521 for x in "$@"; do 627 for x in "$@"; do
522 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 628 pushd "${S}"/${x} >/dev/null || die
523 emake INSTALL_ROOT="${D}" install || die "emake install failed" 629 emake INSTALL_ROOT="${D}" install || die "emake install failed"
524 popd >/dev/null || die "Can't popd from ${S}/${x}" 630 popd >/dev/null || die
525 done 631 done
526} 632}
527 633
528# @ECLASS-VARIABLE: QCONFIG_ADD 634# @ECLASS-VARIABLE: QCONFIG_ADD
529# @DESCRIPTION: 635# @DESCRIPTION:
539# @DESCRIPTION: 645# @DESCRIPTION:
540# List variables that should be defined at the top of QtCore/qconfig.h 646# List variables that should be defined at the top of QtCore/qconfig.h
541: ${QCONFIG_DEFINE:=} 647: ${QCONFIG_DEFINE:=}
542 648
543# @FUNCTION: install_qconfigs 649# @FUNCTION: install_qconfigs
650# @INTERNAL
651# @DESCRIPTION:
544# @DESCRIPTION: Install gentoo-specific mkspecs configurations 652# Install gentoo-specific mkspecs configurations.
545install_qconfigs() { 653install_qconfigs() {
546 local x 654 local x
547 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 655 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
548 for x in QCONFIG_ADD QCONFIG_REMOVE; do 656 for x in QCONFIG_ADD QCONFIG_REMOVE; do
549 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 657 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
560 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 668 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
561 fi 669 fi
562} 670}
563 671
564# @FUNCTION: generate_qconfigs 672# @FUNCTION: generate_qconfigs
565# @DESCRIPTION: Generates gentoo-specific configurations 673# @INTERNAL
674# @DESCRIPTION:
675# Generates gentoo-specific qconfig.{h,pri}.
566generate_qconfigs() { 676generate_qconfigs() {
567 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 677 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
568 local x qconfig_add qconfig_remove qconfig_new 678 local x qconfig_add qconfig_remove qconfig_new
569 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 679 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
570 [[ -f ${x} ]] || continue 680 [[ -f ${x} ]] || continue
571 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 681 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
572 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 682 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
584 694
585 # generate list of QT_CONFIG entries from the existing list 695 # generate list of QT_CONFIG entries from the existing list
586 # including qconfig_add and excluding qconfig_remove 696 # including qconfig_add and excluding qconfig_remove
587 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 697 for x in $(sed -n 's/^QT_CONFIG +=//p' \
588 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 698 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
589 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 699 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
590 done 700 done
591 701
592 # replace the existing QT_CONFIG list with qconfig_new 702 # replace the existing QT_CONFIG list with qconfig_new
593 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 703 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
594 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 704 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
618 fi 728 fi
619 fi 729 fi
620} 730}
621 731
622# @FUNCTION: qt4-build_pkg_postrm 732# @FUNCTION: qt4-build_pkg_postrm
733# @DESCRIPTION:
623# @DESCRIPTION: Generate configurations when the package is completely removed 734# Regenerate configuration when the package is completely removed.
624qt4-build_pkg_postrm() { 735qt4-build_pkg_postrm() {
625 generate_qconfigs 736 generate_qconfigs
626} 737}
627 738
628# @FUNCTION: qt4-build_pkg_postinst 739# @FUNCTION: qt4-build_pkg_postinst
740# @DESCRIPTION:
629# @DESCRIPTION: Generate configuration, plus throws a message about possible 741# Regenerate configuration, plus throw a message about possible
630# breakages and proposed solutions. 742# breakages and proposed solutions.
631qt4-build_pkg_postinst() { 743qt4-build_pkg_postinst() {
632 generate_qconfigs 744 generate_qconfigs
633} 745}
634 746
635# @FUNCTION: skip_qmake_build_patch 747# @FUNCTION: skip_qmake_build
748# @INTERNAL
636# @DESCRIPTION: 749# @DESCRIPTION:
637# Don't need to build qmake, as it's already installed from qt-core 750# Patches configure to skip qmake compilation, as it's already installed by qt-core.
638skip_qmake_build_patch() { 751skip_qmake_build() {
639 # Don't need to build qmake, as it's already installed from qt-core
640 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 752 sed -i -e "s:if true:if false:g" "${S}"/configure || die
641} 753}
642 754
643# @FUNCTION: skip_project_generation_patch 755# @FUNCTION: skip_project_generation
756# @INTERNAL
644# @DESCRIPTION: 757# @DESCRIPTION:
645# Exit the script early by throwing in an exit before all of the .pro files are scanned 758# Exit the script early by throwing in an exit before all of the .pro files are scanned.
646skip_project_generation_patch() { 759skip_project_generation() {
647 # Exit the script early by throwing in an exit before all of the .pro files are scanned
648 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 760 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
649 -i "${S}"/configure || die "Sed failed"
650} 761}
651 762
652# @FUNCTION: symlink_binaries_to_buildtree 763# @FUNCTION: symlink_binaries_to_buildtree
764# @INTERNAL
653# @DESCRIPTION: 765# @DESCRIPTION:
654# Symlink generated binaries to buildtree so they can be used during compilation 766# Symlinks generated binaries to buildtree, so they can be used during compilation time.
655# time
656symlink_binaries_to_buildtree() { 767symlink_binaries_to_buildtree() {
657 for bin in qmake moc uic rcc; do 768 for bin in qmake moc uic rcc; do
658 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 769 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
659 done 770 done
660} 771}
661 772
662# @FUNCTION: fix_library_files 773# @FUNCTION: fix_library_files
774# @INTERNAL
663# @DESCRIPTION: 775# @DESCRIPTION:
664# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 776# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
665# moves the *.pc-files into the pkgconfig directory 777# moves the *.pc files into the pkgconfig directory.
666fix_library_files() { 778fix_library_files() {
779 local libfile
667 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 780 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
668 if [[ -e ${libfile} ]]; then 781 if [[ -e ${libfile} ]]; then
669 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 782 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
670 fi 783 fi
671 done 784 done
672 785
673 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 786 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
674 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 787 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
675 if [[ -e ${libfile} ]]; then 788 if [[ -e ${libfile} ]]; then
676 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 789 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
677 790
678 # Move .pc files into the pkgconfig directory 791 # Move .pc files into the pkgconfig directory
679 dodir ${QTPCDIR#${EPREFIX}} 792 dodir ${QTPCDIR#${EPREFIX}}
680 mv ${libfile} "${D}"/${QTPCDIR}/ \ 793 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
681 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
682 fi 794 fi
683 done 795 done
684 796
685 # Don't install an empty directory 797 # Don't install an empty directory
686 rmdir "${D}"/${QTLIBDIR}/pkgconfig 798 rmdir "${D}"/${QTLIBDIR}/pkgconfig
687} 799}
688 800
689# @FUNCTION: qt_use 801# @FUNCTION: qt_use
690# @USAGE: < flag > [ feature ] [ enableval ] 802# @USAGE: < flag > [ feature ] [ enableval ]
691# @DESCRIPTION: 803# @DESCRIPTION:
692# This will echo "${enableval}-${feature}" if <flag> is enabled, or 804# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
693# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 805# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
694# will be used for that. If [enableval] is not specified, it omits the 806# will be used for that. If [enableval] is not specified, it omits the
695# assignment-part 807# "-${enableval}" part.
696qt_use() { 808qt_use() {
697 local flag=$1 809 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
698 local feature=$1
699 local enableval=
700
701 [[ -n $2 ]] && feature=$2
702 [[ -n $3 ]] && enableval=-$3
703
704 if use ${flag}; then
705 echo "${enableval}-${feature}"
706 else
707 echo "-no-${feature}"
708 fi
709} 810}
710 811
711# @FUNCTION: qt_mkspecs_dir 812# @FUNCTION: qt_mkspecs_dir
712# @RETURN: the specs-directory w/o path 813# @RETURN: the specs-directory w/o path
713# @DESCRIPTION: 814# @DESCRIPTION:
714# Allows us to define which mkspecs dir we want to use. 815# Allows us to define which mkspecs dir we want to use.
715qt_mkspecs_dir() { 816qt_mkspecs_dir() {
716 # Allows us to define which mkspecs dir we want to use.
717 local spec 817 local spec=
718 818
719 case ${CHOST} in 819 case "${CHOST}" in
720 *-freebsd*|*-dragonfly*) 820 *-freebsd*|*-dragonfly*)
721 spec=freebsd ;; 821 spec=freebsd ;;
722 *-openbsd*) 822 *-openbsd*)
723 spec=openbsd ;; 823 spec=openbsd ;;
724 *-netbsd*) 824 *-netbsd*)
735 *-solaris*) 835 *-solaris*)
736 spec=solaris ;; 836 spec=solaris ;;
737 *-linux-*|*-linux) 837 *-linux-*|*-linux)
738 spec=linux ;; 838 spec=linux ;;
739 *) 839 *)
740 die "Unknown CHOST, no platform choosen." 840 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
741 esac 841 esac
742 842
743 CXX=$(tc-getCXX) 843 case "$(tc-getCXX)" in
744 if [[ ${CXX} == *g++* ]]; then 844 *g++*)
745 spec+=-g++ 845 spec+=-g++ ;;
746 elif [[ ${CXX} == *icpc* ]]; then 846 *icpc*)
747 spec+=-icc 847 spec+=-icc ;;
748 else 848 *)
749 die "Unknown compiler ${CXX}." 849 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
750 fi 850 esac
751 if [[ -n ${LIBDIR/lib} ]]; then
752 spec+=-${LIBDIR/lib}
753 fi
754 851
755 # Add -64 for 64bit profiles 852 # Add -64 for 64bit profiles
756 if use x64-freebsd || 853 if use x64-freebsd ||
757 use amd64-linux || 854 use amd64-linux ||
758 use x64-macos || 855 use x64-macos ||
763 fi 860 fi
764 861
765 echo "${spec}" 862 echo "${spec}"
766} 863}
767 864
768# @FUNCTION: qt_assistant_cleanup
769# @RETURN: nothing
770# @DESCRIPTION:
771# Tries to clean up tools.pro for qt-assistant ebuilds
772# Meant to be called in src_prepare
773qt_assistant_cleanup() {
774 # different versions (and branches...) may need different handling,
775 # add a case if you need special handling
776 case "${MY_PV_EXTRA}" in
777 *kde-qt*)
778 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
779 -e "/mac/,/^embedded.*makeqpf$/d" \
780 -i tools/tools.pro || die "patching tools.pro failed"
781 ;;
782 *)
783 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
784 -e "/mac/,/^embedded.*makeqpf$/d" \
785 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
786 -i tools/tools.pro || die "patching tools.pro failed"
787 ;;
788 esac
789}
790
791# @FUNCTION: qt_nolibx11 865# @FUNCTION: qt_nolibx11
792# @RETURN: nothing 866# @INTERNAL
793# @DESCRIPTION: 867# @DESCRIPTION:
794# Ignore X11 tests for packages that don't need X libraries installed 868# Ignore X11 tests for packages that don't need X libraries installed.
795qt_nolibx11() { 869qt_nolibx11() {
796 einfo "removing X11 check to allow X-less compilation"
797 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 870 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
798 die "x11 check sed failed" 871 die "x11 check sed failed"
799} 872}
800 873
801EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 874EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.89  
changed lines
  Added in v.1.133

  ViewVC Help
Powered by ViewVC 1.1.20